#!/usr/bin/env python
# -*- coding: utf-8 -*-
# coding=utf8

import os.path
import os
import gimp
from gimpfu import *

def new_flat_colors(image, active_layer, curve):

    pdb.gimp_selection_none(image)
    #image.clean_all()
    pdb.gimp_edit_copy(active_layer)
    target_image = pdb.gimp_edit_paste_as_new()
    target_image.disable_undo()

    if target_image.base_type != 1:
        pdb.gimp_image_convert_grayscale(target_image)
    target_image.flatten()
    target_image.layers[0].name = "Background"

    #Since there isn't a threshold option when converting to one bit images, a curve come handy.
    if curve:
        pdb.gimp_curves_explicit(target_image.layers[0], 0, 256, [a**2/255 for a in range(256)])

    #Convert to two colors
    pdb.gimp_image_convert_indexed(target_image, NO_DITHER, MONO_PALETTE, 2, 0, 0, "")

    #Mi stupid plugin doesn't understand indexed images.
    pdb.gimp_image_convert_rgb(target_image)

    pdb.plug_in_multifill(target_image, target_image.layers[0])
    pdb.plug_in_flatten(target_image, target_image.layers[0])

    pdb.gimp_edit_copy(active_layer)

    line_layer = pdb.gimp_edit_paste(target_image.active_drawable,0)
    pdb.gimp_floating_sel_to_layer(line_layer)
    line_layer.mode = MULTIPLY_MODE
    line_layer.name = "Outlines"

    target_image.enable_undo()
    #target_image.clean_all()
    display = pdb.gimp_display_new(target_image)

register(
	"new_flat_colors",
	"Create a two layer image for flatting work.\n\n(Applying a curve helps to close small outline gaps)",
	"Uses the fast multifill and flatten plugins to create a two layer image with the outlines on top.\nAn optional curve increases the chance of isolating areas.",
	"",
	"",
	"",
	"<Image>/Filters/Flatting/Create New",
	"RGB*, GRAY*",
	[
        (PF_TOGGLE, "curve", "Apply curve", 0),
        ],
	[],new_flat_colors)

main()
